{===================================================================================================

  Comming BASE

     ,  (QuickReport), .

====================================================================================================

  :

  19.10.2004 [*] .
  09.04.2004 [+]   (,  RTF ).
  15.04.2003 [+]   MWF-.
  07.12.2002 [*]     .
  04.11.2002 [*]    .
  31.10.2002 [*]    .
  25.10.2002 [+]     .
  24.10.2002 [-]   .
  23.10 2002 [*]    .
  14.10.2002 [*]    .
  18.09.2002 [*]   ToolBar2000.
  22.05.2002 [-]  .
  06.02.2002 [+]     .
  08.01.2002 [+]     .
             [+]    .
  27.12.2001 [+]   .
  26.12.2001 [*]     .
  17.12.2001 [*]     ( ).
             [+]   .
             [-]  .
  03.07.2001 [*]   Delphi6.
  18.06.2001 [+]  .
  14.06.2001 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrPreview.pas,v 1.8 2010/01/26 04:48:24 tsk Exp $
===================================================================================================}
unit BASEfrPreview;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, QRPrntr,
      ComCtrls, ActnList, QuickRpt, ExtCtrls, TB2Item, TB2Dock, TB2Toolbar, Menus,
      PropFilerEh, PropStorageEh,
      // BASE
      BASEfrRootClient,
      // Comming:
      CommingProgressBar;

type
  TBASEPreviewFR = class( TBASERootClientFR )
    prReport: TQRPreview;
    laPage: TLabel;
    acFirst: TAction;
    acPrior: TAction;
    acNext: TAction;
    acLast: TAction;
    acZoom10Plus: TAction;
    acZoom10Minus: TAction;
    acZoomWidth: TAction;
    acZoomToFit: TAction;
    acPrinterSetup: TAction;
    acPrint: TAction;
    acPrintAll: TAction;
    acSwitch: TAction;
    TBSeparatorItem2: TTBSeparatorItem;
    TBSeparatorItem3: TTBSeparatorItem;
    imSwitch: TTBSubmenuItem;
    btPrior: TTBItem;
    TBItem2: TTBItem;
    TBItem3: TTBItem;
    TBItem4: TTBItem;
    tblaPage: TTBControlItem;
    TBSeparatorItem4: TTBSeparatorItem;
    TBItem5: TTBItem;
    TBItem6: TTBItem;
    TBItem8: TTBItem;
    TBSeparatorItem5: TTBSeparatorItem;
    TBItem7: TTBItem;
    TBItem9: TTBItem;
    TBItem10: TTBItem;
    TBItem11: TTBItem;
    btChoice: TTBItem;
    pbDone: TcoProgressBar;
    acChoice: TAction;
    acSave: TAction;
    TBItem1: TTBItem;
    TBSeparatorItem1: TTBSeparatorItem;
    TBSeparatorItem6: TTBSeparatorItem;
    imTools: TTBSubmenuItem;
    TBSeparatorItem7: TTBSeparatorItem;
//    procedure btExitClick(Sender: TObject);
    procedure   acSwitchExecute(Sender: TObject);
    procedure   acChoiceUpdate(Sender: TObject);
    procedure acFirstUpdate(Sender: TObject);
    procedure acFirstExecute(Sender: TObject);
    procedure acPriorExecute(Sender: TObject);
    procedure acNextExecute(Sender: TObject);
    procedure acLastUpdate(Sender: TObject);
    procedure acLastExecute(Sender: TObject);
    procedure acZoom10PlusUpdate(Sender: TObject);
    procedure acZoom10PlusExecute(Sender: TObject);
    procedure acZoom10MinusUpdate(Sender: TObject);
    procedure acZoom10MinusExecute(Sender: TObject);
    procedure acZoomWidthExecute(Sender: TObject);
    procedure acZoomToFitExecute(Sender: TObject);
    procedure RefreshExecute(Sender: TObject);
//    procedure QueryUpdate(Sender: TObject);
//    procedure QueryExecute(Sender: TObject);
    procedure acPrinterSetupExecute(Sender: TObject);
    procedure acPrintUpdate(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure acPrintAllExecute(Sender: TObject);
    procedure acPrintAllUpdate(Sender: TObject);
    procedure SelectReport( Sender: TObject );
    procedure   imExitClick(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
  private   { Private declarations }
    FMulti: Boolean;
  protected { Protected declarations }
    procedure   UpdateStatus;
    procedure   CMQRProgressUpdate( var Message: TCM_QRPRogressUpdate ); message CM_QRPROGRESSUPDATE;
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   Add( AQRPrinter: TQRPrinter );
    procedure   ShowModal; override;
    procedure   MultiBegin;
    procedure   MultiEnd;
    procedure   Clear;
  end;

implementation

{$R *.DFM}
//==================================================================================================
constructor TBASEPreviewFR.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Left    := 0;
  Top     := 0;
  FMulti  := False;
end;
//==================================================================================================
procedure TBASEPreviewFR.ShowModal;
begin
  inherited;
  prReport.ZoomToWidth;
end;
//==================================================================================================
{procedure TBASEPreviewFR.btExitClick( Sender: TObject );
  var i: Integer;
begin
  Screen.Cursor := crHourGlass;
  try
    imSwitch.Clear;
    acSwitch.Enabled := False;
    prReport.PageNumber := 1;
//    prReport.ActivePrinterIndex := 1;
    for i := prReport.PrintersCount - 1 downto 0 do
      try
        prReport.Remove(prReport.QRPrinters[i]);
      except end;
//  prReport.PrinterList.Clear;
//  prReport.QRPrinter := nil;
//  ( Owner as TBASERootFM).tbMain.Visible := True;
  except end;
  Hide;
  Screen.Cursor := crDefault;
end;         }
//==================================================================================================
procedure TBASEPreviewFR.UpdateStatus;
begin
  if prReport.QRPrinter <> nil
    then laPage.Caption := Format( '%d/%d', [ prReport.PageNumber, prReport.QRPrinter.PageCount ])
    else laPage.Caption := '0/0';
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TBASEPreviewFR.acSwitchExecute(Sender: TObject);
  var i: Integer;
begin
  i := prReport.ActivePrinterIndex;
  if ( i = imSwitch.Count - 1 ) then i := 0 else Inc( i );
  imSwitch.Items[i].Click;
end;
//==================================================================================================
procedure TBASEPreviewFR.acChoiceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( prReport.QRPrinter = nil )
                  or (( prReport.QRPrinter <> nil ) and ( prReport.QRPrinter.Status = mpFinished ));
end;
//==================================================================================================
{ Move }
//==================================================================================================
procedure TBASEPreviewFR.acFirstUpdate( Sender: TObject );
begin
  with prReport do begin
    TAction(Sender).Enabled := ( QRPrinter <> nil ) and ( QRPrinter.PageCount > 0 ) and ( PageNumber > 1 );
  end;
  UpdateStatus;
end;
//==================================================================================================
procedure TBASEPreviewFR.acFirstExecute(Sender: TObject);
  var L, V: Integer;
begin
  with prReport do begin
    L := HorzScrollBar.Position;
    V := VertScrollBar.Position;
    PageNumber := 1;
    HorzScrollBar.Position := L;
    VertScrollBar.Position := V;
  end;
end;
//==================================================================================================
procedure TBASEPreviewFR.acPriorExecute(Sender: TObject);
  var L, V: Integer;
begin
  with prReport do begin
    L := HorzScrollBar.Position;
    V := VertScrollBar.Position;
    PageNumber := PageNumber - 1;
    HorzScrollBar.Position := L;
    VertScrollBar.Position := V;
  end;
end;
//==================================================================================================
procedure TBASEPreviewFR.acLastUpdate(Sender: TObject);
begin
  with prReport do begin
    TAction(Sender).Enabled := ( QRPrinter <> nil ) and ( QRPrinter.PageCount > 0 ) and ( PageNumber < QRPrinter.PageCount );
  end;
  UpdateStatus;
end;
//==================================================================================================
procedure TBASEPreviewFR.acNextExecute(Sender: TObject);
  var L, V: Integer;
begin
  with prReport do begin
    L := HorzScrollBar.Position;
    V := VertScrollBar.Position;
    PageNumber := PageNumber + 1;
    if PageNumber <> QRPrinter.PageCount then begin
      HorzScrollBar.Position := L;
      VertScrollBar.Position := V;
    end;
  end;
end;
//==================================================================================================
procedure TBASEPreviewFR.acLastExecute(Sender: TObject);
begin
  with prReport do begin
    PageNumber := QRPrinter.PageCount;
  end;
end;
//==================================================================================================
{ Zoom }
//==================================================================================================
procedure TBASEPreviewFR.acZoom10PlusUpdate(Sender: TObject);
begin
  TAction( Sender ).Enabled := ( prReport.Zoom < qrpMAXZOOM );
//  UpdateStatus;
end;
//==================================================================================================
procedure TBASEPreviewFR.acZoom10PlusExecute(Sender: TObject);
  var Old: Integer;
begin
  with prReport do begin
    Old := Zoom;
    Zoom := Round( Zoom * 1.1);
    if ( Zoom = Old ) then Zoom := Zoom + 1;
    if Zoom > qrpMAXZOOM then Zoom := qrpMAXZOOM;
  end;
end;
//==================================================================================================
procedure TBASEPreviewFR.acZoom10MinusUpdate(Sender: TObject);
begin
  TAction( Sender ).Enabled := ( prReport.Zoom > qrpMINZOOM );
end;
//==================================================================================================
procedure TBASEPreviewFR.acZoom10MinusExecute(Sender: TObject);
begin
  with prReport do begin
    Zoom := Round( Zoom * 0.9);
    if Zoom < qrpMINZOOM then Zoom := qrpMINZOOM;
  end;
end;
//==================================================================================================
procedure TBASEPreviewFR.acZoomWidthExecute(Sender: TObject);
begin
  prReport.ZoomToWidth;
end;
//==================================================================================================
procedure TBASEPreviewFR.acZoomToFitExecute(Sender: TObject);
begin
  prReport.ZoomToFit;
end;
//==================================================================================================
procedure TBASEPreviewFR.RefreshExecute(Sender: TObject);
begin
  prReport.QRPrinter.RePreview;
end;
//==================================================================================================
procedure TBASEPreviewFR.acPrintUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( prReport.QRPrinter <> nil ) and ( prReport.QRPrinter.Status = mpFinished );
end;
//==================================================================================================
procedure TBASEPreviewFR.acPrinterSetupExecute(Sender: TObject);
begin
  prReport.QRPrinter.PrintSetup;
  prReport.QRPrinter.RePreview;
end;
//==================================================================================================
procedure TBASEPreviewFR.acPrintExecute(Sender: TObject);
begin
  prReport.QRPrinter.Client := Self;
  prReport.QRPrinter.Print;
end;
//==================================================================================================
procedure TBASEPreviewFR.acPrintAllUpdate(Sender: TObject);
begin
  TAction( Sender ).Enabled := ( prReport.QRPrinter <> nil ) and
                               ( prReport.QRPrinter.Status = mpFinished ) and
                               ( prReport.PrintersCount > 1 )    ;
end;
//==================================================================================================
procedure TBASEPreviewFR.acPrintAllExecute(Sender: TObject);
  var i: Integer;
begin
  with prReport do
    for i := PrintersCount-1 downto 0 do begin
      TCustomQuickRep( QRPrinters[I].Master ).PrinterSettings.FirstPage := 0;
      TCustomQuickRep( QRPrinters[I].Master ).PrinterSettings.LastPage  := 0;
      QRPrinters[I].Client := Self;
      QRPrinters[I].Print;
    end;
end;
//==================================================================================================
procedure TBASEPreviewFR.Add( AQRPrinter: TQRPrinter );
  var Item: TTBItem;
begin
  if FMulti then begin
    repeat
      Application.ProcessMessages;
    until AQRPrinter.Status = mpFinished;
    Item := TTBItem.Create( Self );
    Item.Caption    := AQRPrinter.Title;
    Item.GroupIndex := 1;
//    Item.Checked    := True;
    Item.OnClick    := SelectReport;
    imSwitch.Add( Item );
    imSwitch.Items[0].Checked := True;
//    btSelect.Enabled := ( pmReport.Items.Count > 1 );
  end;
  prReport.Add( AQRPrinter );
//  AQRPrinter.Client := Self;
  prReport.UpdateZoom;
end;
//==================================================================================================
procedure TBASEPreviewFR.SelectReport( Sender: TObject );
begin
  ( Sender as TTBItem ).Checked := True;
  prReport.ActivePrinterIndex := imSwitch.IndexOf(( Sender as TTBItem ));
  prReport.UpdateZoom;
end;
//==================================================================================================
procedure TBASEPreviewFR.MultiBegin;
begin
  FMulti            := True;
  acSwitch.Enabled  := False;
  imExit.Enabled    := False;
end;
//==================================================================================================
procedure TBASEPreviewFR.MultiEnd;
begin
  FMulti            := False;
  imExit.Enabled    := True;
  acSwitch.Enabled  := ( imSwitch.Count > 1 );
end;
//==================================================================================================
procedure TBASEPreviewFR.Clear;
begin
  try
    prReport.QRPrinters[prReport.ActivePrinterIndex].Client := nil;
    prReport.PageNumber := 1;
    prReport.Remove(prReport.QRPrinters[prReport.ActivePrinterIndex]);
  except end;
end;
//==================================================================================================
procedure TBASEPreviewFR.imExitClick(Sender: TObject);
  var i: Integer;
begin
  Screen.Cursor := crHourGlass;
  try
    imSwitch.Clear;
    acSwitch.Enabled := False;
    prReport.PageNumber := 1;
//    prReport.ActivePrinterIndex := 1;
    for i := prReport.PrintersCount - 1 downto 0 do
      try
        prReport.Remove(prReport.QRPrinters[i]);
      except end;
//  prReport.PrinterList.Clear;
//  prReport.QRPrinter := nil;
//  ( Owner as TBASERootFM).tbMain.Visible := True;
  except end;
  Screen.Cursor := crDefault;
  inherited;
end;
//==================================================================================================
procedure TBASEPreviewFR.CMQRProgressUpdate( var Message: TCM_QRPRogressUpdate );
begin
  pbDone.Position := Message.Position;
  if ( Message.Position > 0 ) and not pbDone.Visible then begin
    pbDone.Visible := True;
    pbDone.Caption := Message.QRPrinter.Title;
  end;
  if Message.Position = 100 then pbDone.Visible := False;
end;
//==================================================================================================
procedure TBASEPreviewFR.acSaveExecute(Sender: TObject);
  var MetaFile: TMetaFile;
      i: integer;
begin
  with prReport.QRPrinter do
    for i := 1 to PageNumber do begin
      MetaFile := GetPage(i);
      if Assigned( MetaFile ) then begin
        MetaFile.SaveToFile( Owner.Name + Format( '%3.3d', [i] ) + '.wmf' );
        MetaFile.Free;
      end;
    end;
end;
//==================================================================================================
end.
