{===================================================================================================

  Comming BASE

       .

====================================================================================================

  :

  17.09.2008 [+] .
  19.08.2003 [-]   .
  17.04.2002 [+] " ".
  21.02.2002 [+] "".
  18.01.2002 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEqrReport.pas,v 1.7 2008/09/23 06:15:40 tsk Exp $
===================================================================================================}
unit BASEqrReport;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, Qrctrls,
      QuickRpt, ExtCtrls, DB, ADODB, PropStorageEh, Menus, PropFilerEh,
      // BASE:
      BASEqrRoot;

type
  TBASEReportQR = class( TBASERootQR )
    bnPageHeader: TQRBand;
    laPage: TQRSysData;
    laHeadTitle: TQRSysData;
    bnTitle: TQRBand;
    laTitle: TQRSysData;
    bnColumnHeader: TQRBand;
    bnDetail: TQRBand;
    bnSummary: TQRBand;
    bnUser: TQRChildBand;
    laUser: TQRLabel;
    taUser: TADODataSet;
    taUserUserName: TStringField;
    taUserCurrDateTime: TDateTimeField;
    laSubTitle: TQRLabel;
    taData: TADODataSet;
    bnNoData: TQRChildBand;
    QRLabel18: TQRLabel;
    procedure bnUserBeforePrint(Sender: TQRCustomBand; var PrintBand: Boolean);
    procedure QuickRepPreview(Sender: TObject);
  private   { Private declarations }
    FNoData: Boolean;
    procedure SetNoData(const Value: Boolean);
    property  NoData: Boolean read FNoData write SetNoData;
  public    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.dfm}
//==================================================================================================
constructor TBASEReportQR.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FNoData := False;
end;
//==================================================================================================
procedure TBASEReportQR.QuickRepPreview(Sender: TObject);
begin
  if Self.DataSet = taData then NoData := ( not taData.Active ) or ( taData.RecordCount = 0 );
  inherited;
end;
//==================================================================================================
procedure TBASEReportQR.SetNoData(const Value: Boolean);
  var i: Integer;
begin
  if FNoData <> Value then begin
    FNoData := Value;
    for i := 0 to ComponentCount - 1 do
      if ( Components[i] is TQRCustomBand )
        then ( Components[i] as TQRCustomBand ).Enabled := not Value;
    bnTitle.Enabled   := True;
    bnNoData.Enabled  := Value;
  end;
end;
//==================================================================================================
procedure TBASEReportQR.bnUserBeforePrint(Sender: TQRCustomBand; var PrintBand: Boolean);
begin
  try
    taUser.Connection := taData.Connection;
    taUser.Parameters[0].Value := Application.Tag;
    taUser.Open;
    laUser.Caption := ' : ' + taUserUserName.Value + ' (' + taUserCurrDateTime.Text + ').';
    taUser.Close;
  except
    PrintBand := False;
  end;
end;
//==================================================================================================
end.
