{=======================================================================================================================

  Comming BASE

    .  .

========================================================================================================================

  :

  07.05.2013 [*] IsEditState:  .
  30.11.2012 [*] .
  24.07.2010 [*]      .
  10.07.2009 [+] .
  17.03.2005 [*] .
  31.05.2004 [+]  .
  07.04.2004 [*]   -.
  06.02.2004 [+]  .
  31.07.2003 [-]  uses.
  28.05.2003 [*]   .
             [+]   .
  26.03.2003 [-]  uses.
  24.11.2002 [*]  ImageList.
  14.10.2002 [*]  DBNavigator  Action.
  26.01.2002 [*]  "" -   .
  23.01.2002 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfmTableEdit.pas,v 1.14 2013/08/14 05:51:45 tsk Exp $
=======================================================================================================================}
unit BASEfmTableEdit;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, ActnList, ComCtrls,
      StdCtrls, ExtCtrls, Grids, DBGridEh, DB, ADODB, PrnDbgeh, TB2Item, TB2Dock, TB2Toolbar,
      PropStorageEh, PropFilerEh, TB2ExtItems,
      // BASE:
      BASEfmRoot,
      // Comming:
      CommingDBGridEh, CommingOther;

type
  TBASETableEditFM = class( TBASERootFM )
    grTable: TcoDBGridEh;
    taTable: TADODataSet;
    dsTable: TDataSource;
    pnEdit: TPanel;
    prTable: TPrintDBGridEh;
    TBSeparatorItem4: TTBSeparatorItem;
    TBSeparatorItem5: TTBSeparatorItem;
    imPrint: TTBItem;
    acDataFirst: TAction;
    acDataPrior: TAction;
    acDataNext: TAction;
    acDataLast: TAction;
    acDataInsert: TAction;
    acDataDelete: TAction;
    acDataEdit: TAction;
    acDataPost: TAction;
    acDataCancel: TAction;
    TBItem2: TTBItem;
    TBItem3: TTBItem;
    TBItem4: TTBItem;
    TBItem5: TTBItem;
    TBItem6: TTBItem;
    TBItem7: TTBItem;
    TBSeparatorItem6: TTBSeparatorItem;
    TBItem8: TTBItem;
    TBItem9: TTBItem;
    TBItem10: TTBItem;
    acDataPageUp: TAction;
    TBItem11: TTBItem;
    acDataPageDown: TAction;
    TBItem12: TTBItem;
    acRefresh: TAction;
    TBSeparatorItem7: TTBSeparatorItem;
    TBItem13: TTBItem;
    laCaption: TStaticText;
    acGridPrint: TAction;
    edFind: TTBEditItem;
    TBSeparatorItem8: TTBSeparatorItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btPrintClick(Sender: TObject);
    procedure acDataEditExecute(Sender: TObject);
    procedure acDataInsertExecute(Sender: TObject);
    procedure acDataFirstUpdate(Sender: TObject);
    procedure acDataFirstExecute(Sender: TObject);
    procedure acDataInsertUpdate(Sender: TObject);
    procedure acDataPageUpExecute(Sender: TObject);
    procedure acDataPriorExecute(Sender: TObject);
    procedure acDataLastUpdate(Sender: TObject);
    procedure acDataNextExecute(Sender: TObject);
    procedure acDataPageDownExecute(Sender: TObject);
    procedure acDataLastExecute(Sender: TObject);
    procedure acDataEditUpdate(Sender: TObject);
    procedure acDataDeleteExecute(Sender: TObject);
    procedure acDataPostUpdate(Sender: TObject);
    procedure acDataCancelUpdate(Sender: TObject);
    procedure acDataPostExecute(Sender: TObject);
    procedure acDataCancelExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acRefreshUpdate(Sender: TObject);
    procedure grTableSortMarkingChanged(Sender: TObject);
    procedure edFindAcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
  private   { Private declarations }
    FIsEditState: Boolean;
    procedure SetIsEditState( const Value: Boolean );
  public    { Public declarations }
    property  IsEditState: Boolean read FIsEditState write SetIsEditState;
  end;

implementation

{$R *.dfm}
//======================================================================================================================
{ TBASETableEditFM }
//======================================================================================================================
procedure TBASETableEditFM.FormCreate( Sender: TObject );
begin
  inherited;
  taTable.Open;
  PressPanelToPanel( pnBase, pnEdit );
end;
//======================================================================================================================
procedure TBASETableEditFM.FormResize(Sender: TObject);
begin
  inherited;
  grTable.HeightBinding( Self );
end;
//======================================================================================================================
procedure TBASETableEditFM.SetIsEditState(const Value: Boolean);
begin
  if FIsEditState <> Value then begin
    FIsEditState    := Value;
    grTable.Enabled := not Value;
    pnEdit.Visible  := Value;
    imPrint.Enabled := not Value;
  end;
  if not FIsEditState then ActiveControl := grTable;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASETableEditFM.acDataFirstUpdate( Sender: TObject );
begin
  TAction(Sender).Enabled := taTable.Active and ( not taTable.Bof ) and ( not IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataFirstExecute(Sender: TObject);
begin
  taTable.First;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataPageUpExecute(Sender: TObject);
begin
  taTable.MoveBy( - grTable.RowCount + 2 );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataPriorExecute(Sender: TObject);
begin
  taTable.Prior;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataLastUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active and ( not taTable.Eof ) and ( not IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataNextExecute(Sender: TObject);
begin
  taTable.Next;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataPageDownExecute(Sender: TObject);
begin
  taTable.MoveBy( grTable.RowCount - 2 );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataLastExecute(Sender: TObject);
begin
  taTable.Last;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASETableEditFM.acDataInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active and ( not IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataInsertExecute( Sender: TObject );
begin
  IsEditState := True;
  taTable.Insert;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active and ( taTable.RecordCount > 0 ) and ( not IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataEditExecute( Sender: TObject );
begin
  IsEditState := True;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataDeleteExecute(Sender: TObject);
  var ID: Variant;
begin
  with taTable do begin
    Delete;
    Prior;
    if taTable.IndexFieldNames <> '' then ID := taTable.FieldValues[taTable.IndexFieldNames];
    Requery;
    if taTable.IndexFieldNames <> '' then Locate(taTable.IndexFieldNames, ID, []);
  end;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataPostUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active
                             and ( IsEditState ) and ( taTable.State in [ dsInsert, dsEdit ] );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataPostExecute(Sender: TObject);
begin
  taTable.Post;
  IsEditState := False;
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataCancelUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active and ( IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acDataCancelExecute(Sender: TObject);
begin
  taTable.Cancel;
  IsEditState := False;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASETableEditFM.acRefreshUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := taTable.Active and ( not IsEditState );
end;
//======================================================================================================================
procedure TBASETableEditFM.acRefreshExecute(Sender: TObject);
begin
  taTable.Requery;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASETableEditFM.grTableSortMarkingChanged(Sender: TObject);
begin
  grTable.SortMarkingChanged;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TBASETableEditFM.btPrintClick(Sender: TObject);
begin
  inherited;
  prTable.PageHeader.LeftText.Text := Caption;
  prTable.Preview;
end;
//======================================================================================================================
procedure TBASETableEditFM.edFindAcceptText(Sender: TObject; var NewText: String; var Accept: Boolean);
begin
  inherited;
  taTable.Locate( grTable.Columns[0].FieldName, NewText, [ loPartialKey ])
end;
//======================================================================================================================
end.







