{=======================================================================================================================

  Comming BASE

       ( DBGrid)  .

========================================================================================================================

  :

  11.12.2015 [*]      .
  26.11.2015 [+]      ( UNICODE).
  23.01.2012 [*]     .
  22.12.2011 [+]     .
  21.12.2011 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                   http://www.tsklab.ru
  CVS: $Id: BASEfrChoiceGridEdit.pas,v 1.8 2015/12/11 03:57:40 tsk Exp $
=======================================================================================================================}
unit BASEfrChoiceGridEdit;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ActnList,
      DB, ADODB, Grids, DBGridEh, StdCtrls, ExtCtrls,
      // BASE:
      BASEfrRoot, BASEfrChoiceGrid,
      // Comming:
      CommingDBGridEh, CommingButton, CommingFlat, CommingADO, CommingString;

type
  TBASEChoiceDBGridEditFR = class(TBASEChoiceDBGridFR)
    edFind: TcoEdit;
    taChoiceID: TIntegerField;
    taChoiceTitle: TStringField;
    acStartOver: TAction;
    btStartOver: TcoButton;
    btPastFind: TcoButton;
    acPastFind: TAction;
    procedure edFindChange(Sender: TObject);
    procedure acStartOverExecute(Sender: TObject);
    procedure acStartOverUpdate(Sender: TObject);
    procedure acPastFindUpdate(Sender: TObject);
    procedure acPastFindExecute(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    FFind: String;
    FSynonym: Boolean;
    constructor CreateComming( AOwner: TComponent; PAChoice: TChoiceKey; OnTop: Boolean = False; Synonym: Boolean = False );
  end;

implementation

uses ANYdmComming;

{$R *.dfm}
//======================================================================================================================
{ TTBASEChoiceDBGridEditFR }
//======================================================================================================================
constructor TBASEChoiceDBGridEditFR.CreateComming(AOwner: TComponent; PAChoice: TChoiceKey;
                                                                                     OnTop: Boolean; Synonym: Boolean );
begin
  inherited Create( AOwner );
  OnAfterChoice := PAChoice;
  if OnTop then Anchors := [ akTop, akLeft ] else Anchors := [ akRight, akBottom ];
  FieldKey := taChoiceID;
  FSynonym := Synonym;
end;
//======================================================================================================================
procedure TBASEChoiceDBGridEditFR.edFindChange(Sender: TObject);
begin
  if Length( Trim ( edFind.Text )) > 0
    then RequeryParameters( taChoice, [ Trim ( edFind.Text )])
    else RequeryParameters( taChoice, [ #31 ]);
end;
//======================================================================================================================
procedure TBASEChoiceDBGridEditFR.acStartOverUpdate(Sender: TObject);
begin
  TAction(Sender).Visible := (FFind <> EmptyStr ) and ( FFind <> edFind.Text );
end;
//======================================================================================================================
procedure TBASEChoiceDBGridEditFR.acStartOverExecute(Sender: TObject);
begin
  edFind.Text := FFind;
end;
//======================================================================================================================
procedure TBASEChoiceDBGridEditFR.acPastFindUpdate(Sender: TObject);
begin
//  inherited;
  try
    TAction(Sender).Enabled := (GetStringFromClipboard <> EmptyStr );
  except
    TAction(Sender).Enabled := False;
  end;
end;
//======================================================================================================================
procedure TBASEChoiceDBGridEditFR.acPastFindExecute(Sender: TObject);
begin
//  inherited;
  edFind.Text := GetStringFromClipboard;
end;
//======================================================================================================================
end.
